#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "config.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "zip.h"
/*GtkWidget* errMessage=NULL;
GtkWidget* txtMessage=NULL;
GtkWidget *lstTo=NULL;*/
char *zipexe;
float ziplen=0;
void zipCompress(char *saveas){
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  if(methods.zip.Intern==1)
	internZip(saveas);
  else
	externZip(saveas);
}

void zipParseOptions(){
  zipexe=(char*)malloc(2048);
  memset(zipexe,0x0,sizeof(zipexe));
//  strcpy(zipexe,methods.zip.Exe);
  strcpy(zipexe,"-");
  if(methods.zip.Store==1)
	strcat(zipexe,"0");
  else{
	char *temp;
	temp=(char*)malloc(sizeof(temp));
	sprintf(temp,"%d",methods.zip.CompLevel);
	strcat(zipexe,temp);
	free(temp);
  }
  if(methods.zip.RecTop==1)
	strcat(zipexe,"r");
  if(methods.zip.RecCur==1)
	strcat(zipexe,"R");
  if(methods.zip.XtraAttr==1)
	strcat(zipexe,"X");
  if(methods.zip.DirEntries==1)
	strcat(zipexe,"D");
  if(methods.zip.Grow==1)
	strcat(zipexe,"g");
  if(methods.zip.DirNames==1)
	strcat(zipexe,"j");
  if(methods.zip.AsLink==1){
	if(methods.zip.Pkzip==1)
	  strcat(zipexe,"k");
	else
	  strcat(zipexe,"y");
  }
  if(methods.zip.MvFiles==1)
	strcat(zipexe,"m");
}

void externZip(char *saveas){
  FILE *fp;
  char *buffer,*exe[8194],*temp;
  char temp2[256];
  int status=0;
  float nums=0,size=0;
  nums=selTo->numrows;
  gdk_threads_enter();
  lstTo=lookup_widget(winMain,"lstTo");
  for(ziplen=0;;ziplen++){
	if(cancelled==1)
	  break;
	if(gtk_clist_get_text(GTK_CLIST(lstTo),ziplen,0,&buffer)==0)
  	  break;
  	else{
  	  fp=fopen(buffer,"r");
  	  fseek(fp,0L,SEEK_END);
  	  size=ftell(fp);
  	  fclose(fp);
	  gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),0,0,size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/11);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  zipParseOptions();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/10);
  	  while(gtk_events_pending())
  	    gtk_main_iteration();
  	  exe[0]=methods.zip.Exe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/9);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  exe[1]=zipexe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/8);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  if(methods.zip.TempDir==1){
	    temp=(char*)malloc(sizeof(temp));
        gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/7);
    	while(gtk_events_pending())
      	  gtk_main_iteration();	
		strcpy(temp,"-b");
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/6);
      	while(gtk_events_pending())
      	  gtk_main_iteration();	
		exe[2]=temp;
		gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
      	while(gtk_events_pending())
      	  gtk_main_iteration();	
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/4);
      	while(gtk_events_pending())
      	  gtk_main_iteration();	
		exe[3]=methods.zip.TempDirName;
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
      	while(gtk_events_pending())
      	  gtk_main_iteration();
		exe[4]=saveas;
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/2);
      	while(gtk_events_pending())
      	  gtk_main_iteration();		
		exe[5]=buffer;
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/1);
      	while(gtk_events_pending())
      	  gtk_main_iteration();	
  	  }else{
		exe[2]=saveas;
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
      	while(gtk_events_pending())
      	  gtk_main_iteration();	
		exe[3]=buffer;
      	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
      	while(gtk_events_pending())
      	  gtk_main_iteration();	
  	  }
  	  status=mySystem(exe);
//	  printf("status %d\n",status);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),ziplen);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),buffer);
  	  memset(temp2,0x0,sizeof(temp2));
  	  sprintf(temp2,"%1.0f of %1.0f done",ziplen+1,nums);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressTotalFiles")),temp2);
  	  while(gtk_events_pending())
        gtk_main_iteration();
	}
  }
  if(cancelled==1){
//	printf("Cancelled\n");
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG08,strlen(ERR_MSG08));
	gtk_widget_show(errMessage);
  }else{
	memset(exe,0x0,sizeof(zipexe));
	if(methods.zip.AddComment==1){
  	  if((fp=fopen("/tmp/tmp.comment","w"))!=NULL){
  		fprintf(fp,"%s",methods.zip.ZipComment);
  		fclose(fp);
		strcpy(zipexe,methods.zip.Exe);
		strcat(zipexe," -z ");
  		strcat(zipexe,saveas);
  		strcat(zipexe," < /tmp/tmp.comment");
  		system(zipexe);
		unlink("/tmp/tmp.comment");
  	  }
	}else{
  	  if((fp=fopen("/tmp/tmp.comment","r"))!=NULL){
  		fclose(fp);
  		unlink("/tmp/tmp.comment");
  	  }
	}
	if(methods.zip.TestInt==1){
	  memset(exe,0x0,sizeof(exe));
	  exe[0]=methods.zip.Exe;
	  exe[1]="-T";
	  exe[2]=saveas;
	  status=mySystem(exe);
	  if(status==3072){
		gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ZERR_MSG02,strlen(ZERR_MSG02));
		gtk_widget_show(errMessage);
	  }else{
		gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size+=10);
		gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),"Testing the archive");
		while(gtk_events_pending())
  	  	  gtk_main_iteration();	
		gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ZERR_MSG03,strlen(ZERR_MSG03));
		gtk_widget_show(errMessage);
	  }
	}
	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),ziplen+1);
	while(gtk_events_pending())
  	  gtk_main_iteration();	
	gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
	gtk_widget_show(lookup_widget(Progress,"btnProgressClose"));
	gtk_widget_grab_default(lookup_widget(Progress,"btnProgressClose"));
//  gtk_clist_remove(GTK_CLIST(lstTo),ziplen);
	gdk_threads_leave();
  }
}

int internZip(char *saveas){
  return 0;
}  
